#NO_APP
	.text
	.align 1
	.globl bn_mul_add_words
 	.type bn_mul_add_words,@function
bn_mul_add_words:
	;; calculate <r> = <a>*w + <r>
	;; register usage:
	;;   $r10 - BN_ULONG *r, the result and additive source array
	;;   $r11 - BN_ULONG *a, the multiplicative source array
	;;   $r12 - int num, the length of the r & a arrays
	;;   $r13 - BN_ULONG w, the multiplicative scalar
	;;   $r0 to $r7 register bank
	;;   $r8, r9  carry dword (for loop wrap), alternates

	;; put $r0 to $r8 on stackframe (9*4==36 octets)
	push $srp
 	subq 36,$sp
	movem $r8,[$sp]

	subq 8,$r12
	blt LMUL_ADD_LOOP_ENTRY2
	clear.d $r8

LMUL_ADD_LOOP1:	
	movem [$r10],$r7	; read four elems from <r> to register bank

	move.d [$r11+],$r9
	mulu.d $r13,$r9
	add.d $r9,$r7
 	move $mof,$r9
	ax
	addq 0,$r9
	add.d $r8,$r7		; add in carry dword
	ax
	addq 0,$r9		; add in carry bit in hi dword, carry in r9
	
	move.d [$r11+],$r8
	mulu.d $r13,$r8
	add.d $r8,$r6
	move $mof,$r8
	ax
	addq 0,$r8
	add.d $r9,$r6		; add in carry dword
	ax
	addq 0,$r8		; add in carry bit in hi dword, carry in r8
	
	move.d [$r11+],$r9
	mulu.d $r13,$r9
	add.d $r9,$r5
 	move $mof,$r9
	ax
	addq 0,$r9
	add.d $r8,$r5		; add in carry dword
	ax
	addq 0,$r9		; add in carry bit in hi dword, carry in r9
	
	move.d [$r11+],$r8
	mulu.d $r13,$r8
	add.d $r8,$r4
	move $mof,$r8
	ax
	addq 0,$r8
	add.d $r9,$r4		; add in carry dword
	ax
	addq 0,$r8		; add in carry bit in hi dword, carry in r8

	move.d [$r11+],$r9
	mulu.d $r13,$r9
	add.d $r9,$r3
 	move $mof,$r9
	ax
	addq 0,$r9
	add.d $r8,$r3		; add in carry dword
	ax
	addq 0,$r9		; add in carry bit in hi dword, carry in r9

	move.d [$r11+],$r8
	mulu.d $r13,$r8
	add.d $r8,$r2
	move $mof,$r8
	ax
	addq 0,$r8
	add.d $r9,$r2		; add in carry dword
	ax
	addq 0,$r8		; add in carry bit in hi dword, carry in r8

	move.d [$r11+],$r9
	mulu.d $r13,$r9
	add.d $r9,$r1
	move $mof,$r9
	ax
	addq 0,$r9
	add.d $r8,$r1		; add in carry dword
	ax
	addq 0,$r9		; add in carry bit in hi dword, carry in r9

	move.d [$r11+],$r8
	mulu.d $r13,$r8
	add.d $r8,$r0
	move $mof,$r8
	ax
	addq 0,$r8
	add.d $r9,$r0		; add in carry dword
	ax
	addq 0,$r8		; add in carry bit in hi dword, carry in r8
	
	movem $r7,[$r10+]	; write back to <r>

	subq 8,$r12
	bge LMUL_ADD_LOOP1
	nop
	
LMUL_ADD_LOOP_ENTRY2:
	addq 8,$r12
	beq LMUL_ADD_END
	nop
LMUL_ADD_LOOP2:		
	move.d [$r10],$r6	

	move.d [$r11+],$r9
	mulu.d $r13,$r9
	move $mof,$r7

	add.d $r9,$r6
	ax
	addq 0,$r7
	add.d $r8,$r6		; add in carry dword
	ax
	addq 0,$r7		; add in carry bit in hi dword

	move.d $r6,[$r10+]
	
	subq 1,$r12
	bgt LMUL_ADD_LOOP2
	move.d $r7,$r8		; move carry dword to $r8

LMUL_ADD_END:
	move.d $r8, $r10
	;;  do we have a carrybit from $dccr to worry about here?
	movem [$sp+],$r8
	jump [$sp+]
	
	.align 1
	.globl bn_sub_words
 	.type bn_sub_words,@function
bn_sub_words:
	;; register usage:
	;;   $r10 - BN_ULONG *r, the result array
	;;   $r11 - BN_ULONG *a, source array a
	;;   $r12 - BN_ULONG *b, source array b
	;;   $r13 - int n , the length of the arrays
	;;   $r0 to $r7, register bank
	;;   $r8 carry save
	;;   $r9 tmp num counter

	;; put $r0 to $r8 on stackframe (9*4==36 octets)
	subq 36,$sp
	movem $r8,[$sp]	
	clearf c
	move $dccr,$r8
	subq 8,$r13		; are there 8 elems or more?
	blt LSUB_UNROLL_START
	nop
	
LSUB_LOOP_START:
	movem [$r11+],$r7
	;; restore $dccr to continue subtraction
	move $r8,$dccr
	ax
	sub.d [$r12+],$r7
	ax
	sub.d [$r12+],$r6
	ax
	sub.d [$r12+],$r5
	ax
	sub.d [$r12+],$r4
	ax
	sub.d [$r12+],$r3
	ax
	sub.d [$r12+],$r2
	ax
	sub.d [$r12+],$r1
	ax
	sub.d [$r12+],$r0
	;; save $dccr to $r8 (to get the carry flag)
	move $dccr,$r8
	movem $r7,[$r10+]	; move the result to r array

	subq 8,$r13		; are there 8 elems or more left?
	bge LSUB_LOOP_START
	nop

LSUB_UNROLL_START:
	addq 8,$r13
	ble LSUB_END
	nop
LSUB_UNROLL:
	move.d [$r11+],$r0
	move.d [$r12+],$r1
	move $r8,$dccr
	ax
	sub.d $r1,$r0
	move $dccr,$r8
	move.d $r0,[$r10+]
	subq 1,$r13
	bgt LSUB_UNROLL
	nop
LSUB_END: 
	;; done, set the return value and restore registers
	move $r8,$dccr
	ax
	slo $r10
	movem [$sp+],$r8
	Ret
	nop

	.align 1
	.globl bn_add_words
	.type bn_add_words,@function
bn_add_words:
	;; register usage:
	;;   $r10 - BN_ULONG *r, the result array
	;;   $r11 - BN_ULONG *a, source array a
	;;   $r12 - BN_ULONG *b, source array b
	;;   $r13 - int n , the length of the arrays
	;;   $r0 to $r7, register bank
	;;   $r8 carry save
	;;   $r9 tmp num counter

	;; put $r0 to $r8 on stackframe (9*4==36 octets)
	subq 36,$sp
	movem $r8,[$sp]
	clearf c
	move $dccr,$r8
	subq 8,$r13		; are there 8 elems or more?
	blt LADD_UNROLL_START
	nop
	
LADD_LOOP_START:
	movem [$r11+],$r7
	;; restore $dccr to continue addition
	move $r8,$dccr
	ax
	add.d [$r12+],$r7
	ax
	add.d [$r12+],$r6
	ax
	add.d [$r12+],$r5
	ax
	add.d [$r12+],$r4
	ax
	add.d [$r12+],$r3
	ax
	add.d [$r12+],$r2
	ax
	add.d [$r12+],$r1
	ax
	add.d [$r12+],$r0
	;; save the $dccr to $r8 (to get the carry flag)
	move $dccr,$r8
	movem $r7,[$r10+]	; move the result to r array

	subq 8,$r13		; are there 8 elems or more left?
	bge LADD_LOOP_START
	nop

LADD_UNROLL_START:
	addq 8,$r13
	ble LADD_END
	nop	
LADD_UNROLL:
	move.d [$r11+],$r0
	move.d [$r12+],$r1
	move $r8,$dccr
	ax
	add.d $r1,$r0
	move $dccr,$r8
	move.d $r0,[$r10+]
	subq 1,$r13
	bgt LADD_UNROLL
	nop
LADD_END: 
	;; done, set the return value and restore registers
	clear.d $r10
	move $r8,$dccr
	ax
	addq 0,$r10
	movem [$sp+],$r8
	Ret
	nop
	
	.align 1
	.globl bn_mul_words
 	.type bn_mul_words,@function 
bn_mul_words:
	;; calculate <r> = <a>*w
	;; register usage:
	;;   $r10 - BN_ULONG *r, the result array
	;;   $r11 - BN_ULONG *a, the source array
	;;   $r12 - int num, the length of the r & a arrays
	;;   $r13 - BN_ULONG w, the multiplicative scalar
	;;   $r0 - $r7 register bank
	;; 
	;;   $r8 carry dword (for loop wrap)
	;;   $r9 tmp reg for add

	;; put $r0 to $r8 on stackframe (9*4==36 octets)
	push $srp
	subq 36,$sp
	movem $r8,[$sp]

	subq 8,$r12
	blt LMUL_LOOP_2_ENTRY
	clear.d $r8
	
LMUL_LOOP_1:
	movem [$r11+],$r7

 	mulu.d $r13,$r7
	move $mof,$r9
	add.d $r8,$r7
 	ax
 	addq 0,$r9		; carry in r9

	mulu.d $r13,$r6
 	move $mof,$r8
	add.d $r9,$r6
	ax
	addq 0,$r8		; carry in r8

	mulu.d $r13,$r5
 	move $mof,$r9
	add.d $r8,$r5
	ax
	addq 0,$r9		; carry in r9

	mulu.d $r13,$r4
 	move $mof,$r8
	add.d $r9,$r4
	ax
	addq 0,$r8		; carry in r8

 	mulu.d $r13,$r3
	move $mof,$r9
	add.d $r8,$r3
 	ax
 	addq 0,$r9		; carry in r9

	mulu.d $r13,$r2
 	move $mof,$r8
	add.d $r9,$r2
	ax
	addq 0,$r8		; carry in r8

	mulu.d $r13,$r1
 	move $mof,$r9
	add.d $r8,$r1
	ax
	addq 0,$r9		; carry in r9

	mulu.d $r13,$r0
 	move $mof,$r8
	add.d $r9,$r0
	ax
	addq 0,$r8		; carry in r8

	movem $r7,[$r10+]
	subq 8,$r12
	bge LMUL_LOOP_1
	nop
LMUL_LOOP_2_ENTRY:
	addq 8,$r12
	beq LMUL_END
	nop
LMUL_LOOP_2:
	move.d [$r11+],$r0
	mulu.d $r13,$r0
	move $mof,$r9

	add.d $r8,$r0		; add in carry dword
	ax
	addq 0,$r9		; add in carry bit in hi dword
	move.d $r0,[$r10+]
	
	subq 1,$r12
	bgt LMUL_LOOP_2
	move.d $r9,$r8		; move carry dword to $r8

LMUL_END:
	move.d $r8, $r10
	movem [$sp+],$r8
	jump [$sp+]

	.align 1
	.globl bn_sqr_words
	.type bn_sqr_words,@function
bn_sqr_words:
	;; calculate <r> = <a>^2, r is 2*num long, a is num long
	;; register usage:
	;;   $r10 - BN_ULONG *r, the result and additive source array
	;;   $r11 - BN_ULONG *a, the multiplicative source array
	;;   $r12 - int num, the legnth of the r & a arrays
	;; 
	;;   $r0 to $r7, register bank
	;;   $r8 unused
	;; 
	;; put $r0 to $r8 on stackframe (9*4==36 octets)
	push $srp
	subq 36,$sp
	movem $r8,[$sp]
	
	test.d $r12
	ble LSQR_END
	
	move.d $r12,$r9
	subq 8,$r9
	blt LSQR_END_LOOP
	nop

LSQR_LOOP:
	move.d $r9,$r12
 	movem [$r11+],$r7

	mulu.d $r7,$r7
 	move.d $r7,[$r10+]
 	move $mof,[$r10+]

	mulu.d $r6,$r6
 	move.d $r6,[$r10+]
 	move $mof,[$r10+]
	
	mulu.d $r5,$r5
 	move.d $r5,[$r10+]
 	move $mof,[$r10+]
	
	mulu.d $r4,$r4
	move.d $r4,[$r10+]
	move $mof,[$r10+]

	mulu.d $r3,$r3
	move.d $r3,[$r10+]
	move $mof,[$r10+]

	mulu.d $r2,$r2
	move.d $r2,[$r10+]
	move $mof,[$r10+]

	mulu.d $r1,$r1
	move.d $r1,[$r10+]
	move $mof,[$r10+]

	mulu.d $r0,$r0
	move.d $r0,[$r10+]
	move $mof,[$r10+]

	move.d $r12,$r9
	subq 8,$r9
	bge LSQR_LOOP

	test.d $r12
	ble LSQR_END
	nop

LSQR_END_LOOP:
	move.d [$r11+],$r0
	mulu.d $r0,$r0

	move.d $r0,[$r10+]
	move $mof,[$r10+]
	subq 1,$r12
	bgt LSQR_END_LOOP
	nop

LSQR_END:
	movem [$sp+],$r8
	jump [$sp+]
	.align 1
	.globl bn_mul_comba4
 	.type bn_mul_comba4,@function
bn_mul_comba4:
	;; calculate <r> = <a>*<b>, r is 8 long, a,b are 4 long
	;; register usage:
	;;   $r10 - BN_ULONG *r, the result and additive source array
	;;   $r11 - BN_ULONG *a, the multiplicative source array
	;;   $r12 - BN_ULONG *b, the multiplicative source array
	;;   $r0 work copy of $r10 (<r>)
	;;   $r1 work copy of $r11 (<a>)
	;;   $r2 work copy of $r12 (<b>)
	;;   $r3 thru $r5 carry registers
	;; 
	;;   $r6 thru $r8 not used
	;; 

	;; put $r0 to $r5 on stackframe (6*4==24 octets)
	push $srp
	subq 24,$sp
	movem $r5,[$sp]
	;; move indata to $r0-$r3 since we need $r10-$r13 for subroutine calls
	move.d $r10, $r0
	move.d $r11, $r1
	move.d $r12, $r2

	.macro mul_add_c p1,p2,c0,c1,c2
	;; this is basically the mul_add_c macro in asm form, with
	;;    c0 in $r3
	;;    c1 in $r4
	;;    c2 in $r5
	;;    t1 in $r10 (multiplication low dword out)
	;;    t2 in $r11 (multiplication high dword out)
	;;   t is not needed since we get multiplication output in two regs
	move.d \p1,$r10
	move.d \p2,$r11
	mulu.d $r11,$r10
	move $mof,$r11

	add.d $r10,\c0		  ;
	ax
	addq 0,$r11		  ; add in carry, cannot overflow due to
	;;                          size of mul result
	add.d $r11,\c1		  ;
	ax
	addq 0,\c2
	.endm
	
	clear.d $r3
	clear.d $r4
	clear.d $r5
	mul_add_c [$r1],[$r2],$r3,$r4,$r5
	move.d $r3, [$r0+]
	clear.d $r3

	mul_add_c [$r1],[$r2+4],$r4,$r5,$r3
	mul_add_c [$r1+4],[$r2],$r4,$r5,$r3
	move.d $r4, [$r0+]
	clear.d $r4

	mul_add_c [$r1+8],[$r2],$r5,$r3,$r4
	mul_add_c [$r1+4],[$r2+4],$r5,$r3,$r4
	mul_add_c [$r1],[$r2+8],$r5,$r3,$r4
	move.d $r5,[$r0+]
	clear.d $r5

	mul_add_c [$r1+12],[$r2],$r3,$r4,$r5
	mul_add_c [$r1+8],[$r2+4],$r3,$r4,$r5
	mul_add_c [$r1+4],[$r2+8],$r3,$r4,$r5
	mul_add_c [$r1],[$r2+12],$r3,$r4,$r5
	move.d $r3,[$r0+]
	clear.d $r3

	mul_add_c [$r1+12],[$r2+4],$r4,$r5,$r3
	mul_add_c [$r1+8],[$r2+8],$r4,$r5,$r3
	mul_add_c [$r1+4],[$r2+12],$r4,$r5,$r3
	move.d $r4,[$r0+]
	clear.d $r4

	mul_add_c [$r1+8],[$r2+12],$r5,$r3,$r4
	mul_add_c [$r1+12],[$r2+8],$r5,$r3,$r4
	move.d $r5,[$r0+]
	clear.d $r5

	mul_add_c [$r1+12],[$r2+12],$r3,$r4,$r5
	move.d $r3,[$r0+]
	move.d $r4,[$r0+]

	movem [$sp+],$r5
	jump [$sp+]
	
	.globl bn_mul_comba8
 	.type bn_mul_comba8,@function
bn_mul_comba8:
	;; calculate <r> = <a>*<b>, r is 16 long, a,b are 4 long
	;; register usage:
	;;   $r10 - BN_ULONG *r, the result array
	;;   $r11 - BN_ULONG *a, source array
	;;   $r12 - BN_ULONG *b, source array
	;;   $r0 work copy of $r10 (<r>)
	;;   $r1 work copy of $r11 (<a>)
	;;   $r2 work copy of $r12 (<b>)
	;;   $r3 thru $r5 carry registers
	;; 
	;;   $r6 thru $r8 not used
	;; 
	;; $r10 thru $r13 used for subroutine calling
	;; 

	;; put $r0 to $r5 on stackframe (6*4==24 octets)
	push $srp
	subq 24,$sp
	movem $r5,[$sp]
	;; move indata to $r0-$r3 since we need $r10-$r13 for subroutine calls
	move.d $r10, $r0
	move.d $r11, $r1
	move.d $r12, $r2

	clear.d $r3
	clear.d $r4
	clear.d $r5

	mul_add_c [$r1],[$r2],$r3,$r4,$r5
	move.d $r3, [$r0+]
	clear.d $r3

	mul_add_c [$r1],[$r2+4],$r4,$r5,$r3
	mul_add_c [$r1+4],[$r2],$r4,$r5,$r3
	move.d $r4, [$r0+]
	clear.d $r4

	mul_add_c [$r1+8],[$r2],$r5,$r3,$r4
	mul_add_c [$r1+4],[$r2+4],$r5,$r3,$r4
	mul_add_c [$r1],[$r2+8],$r5,$r3,$r4
	move.d $r5, [$r0+]
	clear.d $r5

	mul_add_c [$r1],[$r2+12],$r3,$r4,$r5
	mul_add_c [$r1+4],[$r2+8],$r3,$r4,$r5
	mul_add_c [$r1+8],[$r2+4],$r3,$r4,$r5
	mul_add_c [$r1+12],[$r2],$r3,$r4,$r5
	move.d $r3, [$r0+]
	clear.d $r3
	
	mul_add_c [$r1+16],[$r2],$r4,$r5,$r3
	mul_add_c [$r1+12],[$r2+4],$r4,$r5,$r3
	mul_add_c [$r1+8],[$r2+8],$r4,$r5,$r3
	mul_add_c [$r1+4],[$r2+12],$r4,$r5,$r3
	mul_add_c [$r1],[$r2+16],$r4,$r5,$r3
	move.d $r4, [$r0+]
	clear.d $r4

	mul_add_c [$r1],[$r2+20],$r5,$r3,$r4
	mul_add_c [$r1+4],[$r2+16],$r5,$r3,$r4
	mul_add_c [$r1+8],[$r2+12],$r5,$r3,$r4
	mul_add_c [$r1+12],[$r2+8],$r5,$r3,$r4
	mul_add_c [$r1+16],[$r2+4],$r5,$r3,$r4
	mul_add_c [$r1+20],[$r2],$r5,$r3,$r4
	move.d $r5, [$r0+]
	clear.d $r5

	mul_add_c [$r1+24],[$r2],$r3,$r4,$r5
	mul_add_c [$r1+20],[$r2+4],$r3,$r4,$r5
	mul_add_c [$r1+16],[$r2+8],$r3,$r4,$r5
	mul_add_c [$r1+12],[$r2+12],$r3,$r4,$r5
	mul_add_c [$r1+8],[$r2+16],$r3,$r4,$r5
	mul_add_c [$r1+4],[$r2+20],$r3,$r4,$r5
	mul_add_c [$r1],[$r2+24],$r3,$r4,$r5
	move.d $r3, [$r0+]
	clear.d $r3

	mul_add_c [$r1],[$r2+28],$r4,$r5,$r3
	mul_add_c [$r1+4],[$r2+24],$r4,$r5,$r3
	mul_add_c [$r1+8],[$r2+20],$r4,$r5,$r3
	mul_add_c [$r1+12],[$r2+16],$r4,$r5,$r3
	mul_add_c [$r1+16],[$r2+12],$r4,$r5,$r3
	mul_add_c [$r1+20],[$r2+8],$r4,$r5,$r3
	mul_add_c [$r1+24],[$r2+4],$r4,$r5,$r3
	mul_add_c [$r1+28],[$r2],$r4,$r5,$r3
	move.d $r4, [$r0+]
	clear.d $r4

	mul_add_c [$r1+28],[$r2+4],$r5,$r3,$r4
	mul_add_c [$r1+24],[$r2+8],$r5,$r3,$r4
	mul_add_c [$r1+20],[$r2+12],$r5,$r3,$r4
	mul_add_c [$r1+16],[$r2+16],$r5,$r3,$r4
	mul_add_c [$r1+12],[$r2+20],$r5,$r3,$r4
	mul_add_c [$r1+8],[$r2+24],$r5,$r3,$r4
	mul_add_c [$r1+4],[$r2+28],$r5,$r3,$r4
	move.d $r5, [$r0+]
	clear.d $r5

	mul_add_c [$r1+8],[$r2+28],$r3,$r4,$r5
	mul_add_c [$r1+12],[$r2+24],$r3,$r4,$r5
	mul_add_c [$r1+16],[$r2+20],$r3,$r4,$r5
	mul_add_c [$r1+20],[$r2+16],$r3,$r4,$r5
	mul_add_c [$r1+24],[$r2+12],$r3,$r4,$r5
	mul_add_c [$r1+28],[$r2+8],$r3,$r4,$r5
	move.d $r3, [$r0+]
	clear.d $r3

	mul_add_c [$r1+28],[$r2+12],$r4,$r5,$r3
	mul_add_c [$r1+24],[$r2+16],$r4,$r5,$r3
	mul_add_c [$r1+20],[$r2+20],$r4,$r5,$r3
	mul_add_c [$r1+16],[$r2+24],$r4,$r5,$r3
	mul_add_c [$r1+12],[$r2+28],$r4,$r5,$r3
	move.d $r4, [$r0+]
	clear.d $r4

	mul_add_c [$r1+16],[$r2+28],$r5,$r3,$r4
	mul_add_c [$r1+20],[$r2+24],$r5,$r3,$r4
	mul_add_c [$r1+24],[$r2+20],$r5,$r3,$r4
	mul_add_c [$r1+28],[$r2+16],$r5,$r3,$r4
	move.d $r5, [$r0+]
	clear.d $r5

	mul_add_c [$r1+28],[$r2+20],$r3,$r4,$r5
	mul_add_c [$r1+24],[$r2+24],$r3,$r4,$r5
	mul_add_c [$r1+20],[$r2+28],$r3,$r4,$r5
	move.d $r3, [$r0+]
	clear.d $r3
	
	mul_add_c [$r1+24],[$r2+28],$r4,$r5,$r3
	mul_add_c [$r1+28],[$r2+24],$r4,$r5,$r3
	move.d $r4, [$r0+]
	clear.d $r4

	mul_add_c [$r1+28],[$r2+28],$r5,$r3,$r4
	move.d $r5, [$r0+]
	move.d $r3, [$r0+]

	movem [$sp+],$r5
	jump [$sp+]

	.align 1
	.globl bn_sqr_comba4
 	.type bn_sqr_comba4,@function 
bn_sqr_comba4:
	;; calculate <r> = <a>**2, r is 8 long, a is 4 long
	;; register usage:
	;;   $r10 - BN_ULONG *r, the result array
	;;   $r11 - BN_ULONG *a, the source array
	;;   $r0 work copy of $r10 (<r>)
	;;   $r1 work copy of $r11 (<a>)
	;;   $r2 thru $r4 carry registers
	;; 
	;;   $r5 thru $r8 not used
	;; 
	;; $r10 thru $r13 used for subroutine calling
	;; 

	;; put $r0 to $r4 on stackframe (5*4==20 octets)
	push $srp
	subq 20,$sp
	movem $r4,[$sp]
	;; move indata to $r0-$r2 since we need $r10-$r13 multiplication calls
	move.d $r10, $r0
	move.d $r11, $r1

	.macro sqr_add_c p0,c0,c1,c2
	move.d \p0,$r10
	mulu.d $r10,$r10
	move $mof,$r11

	add.d $r10,\c0		  ;
	ax
	addq 0,$r11		  ; add in carry, cannot overflow due to
	;;                          size of mul result
	add.d $r11,\c1		  ;
	ax
	addq 0,\c2
	.endm

	.macro sqr_add_c2 p0,p1,c0,c1,c2	
	move.d \p0,$r10
	move.d \p1,$r11
	mulu.d $r11,$r10
	move $mof,$r11


	move.d $r10,$r12
	move.d $r11,$r13
	add.d $r12,$r10
	ax
	add.d $r13,$r11
	ax
	addq 0,\c2
	add.d $r10,\c0
	ax
	addq 0,$r11
	ax
	addq 0,\c2
	add.d $r11,\c1
	ax
	addq 0,\c2
	.endm

	clear.d $r2
	clear.d $r3
	clear.d $r4

	sqr_add_c [$r1],$r2,$r3,$r4
	move.d $r2, [$r0+]
	clear.d $r2

	sqr_add_c2 [$r1+4],[$r1],$r3,$r4,$r2
	move.d $r3, [$r0+]
	clear.d $r3

	sqr_add_c [$r1+4],$r4,$r2,$r3
	sqr_add_c2 [$r1+8],[$r1],$r4,$r2,$r3
	move.d $r4,[$r0+]
	clear.d $r4

	sqr_add_c2 [$r1+12],[$r1],$r2,$r3,$r4
	sqr_add_c2 [$r1+8],[$r1+4],$r2,$r3,$r4
	move.d $r2,[$r0+]
	clear.d $r2

	sqr_add_c [$r1+8],$r3,$r4,$r2
	sqr_add_c2 [$r1+12],[$r1+4],$r3,$r4,$r2
	move.d $r3,[$r0+]
	clear.d $r3

	sqr_add_c2 [$r1+12],[$r1+8],$r4,$r2,$r3
	move.d $r4,[$r0+]
	clear.d $r4

	sqr_add_c [$r1+12],$r2,$r3,$r4
	move.d $r2,[$r0+]
	move.d $r3,[$r0+]	
	
	movem [$sp+],$r4
	jump [$sp+]


	.align 1
	.globl bn_sqr_comba8
 	.type bn_sqr_comba8,@function
bn_sqr_comba8:
	;; calculate <r> = <a>**2, r is 16 long, a is 4 long
	;; register usage:
	;;   $r10 - BN_ULONG *r, the result array
	;;   $r11 - BN_ULONG *a, the source array
	;;   $r0 work copy of $r10 (<r>)
	;;   $r1 work copy of $r11 (<a>)
	;;   $r2 thru $r4 carry registers
	;; 
	;;   $r5 thru $r9 not used
	;; 
	;; $r10 thru $r13 used for subroutine calling
	;; 

	;; put $r0 to $r4 on stackframe (5*4==20 octets)
	push $srp
	subq 20,$sp
	movem $r4,[$sp]
	;; move indata to $r0-$r2 since we need $r10-$r13 for subroutine calls
	move.d $r10, $r0
	move.d $r11, $r1

	clear.d $r2
	clear.d $r3
	clear.d $r4

	sqr_add_c [$r1],$r2,$r3,$r4
	move.d $r2,[$r0+]
	clear.d $r2
	
	sqr_add_c2 [$r1+4],[$r1],$r3,$r4,$r2
	move.d $r3,[$r0+]
	clear.d $r3

	sqr_add_c [$r1+4],$r4,$r2,$r3
	sqr_add_c2 [$r1+8],[$r1],$r4,$r2,$r3
	move.d $r4,[$r0+]
	clear.d $r4

	sqr_add_c2 [$r1+12],[$r1],$r2,$r3,$r4
	sqr_add_c2 [$r1+8],[$r1+4],$r2,$r3,$r4
	move.d $r2,[$r0+]
	clear.d $r2

	sqr_add_c [$r1+8],$r3,$r4,$r2
	sqr_add_c2 [$r1+12],[$r1+4],$r3,$r4,$r2
	sqr_add_c2 [$r1+16],[$r1],$r3,$r4,$r2
	move.d $r3,[$r0+]
	clear.d $r3

	sqr_add_c2 [$r1+20],[$r1],$r4,$r2,$r3
	sqr_add_c2 [$r1+16],[$r1+4],$r4,$r2,$r3
	sqr_add_c2 [$r1+12],[$r1+8],$r4,$r2,$r3
	move.d $r4,[$r0+]
	clear.d $r4

	sqr_add_c [$r1+12],$r2,$r3,$r4
	sqr_add_c2 [$r1+16],[$r1+8],$r2,$r3,$r4
	sqr_add_c2 [$r1+20],[$r1+4],$r2,$r3,$r4
	sqr_add_c2 [$r1+24],[$r1],$r2,$r3,$r4
	move.d $r2,[$r0+]
	clear.d $r2

	sqr_add_c2 [$r1+28],[$r1],$r3,$r4,$r2
	sqr_add_c2 [$r1+24],[$r1+4],$r3,$r4,$r2
	sqr_add_c2 [$r1+20],[$r1+8],$r3,$r4,$r2
	sqr_add_c2 [$r1+16],[$r1+12],$r3,$r4,$r2
	move.d $r3,[$r0+]
	clear.d $r3

	sqr_add_c [$r1+16],$r4,$r2,$r3
	sqr_add_c2 [$r1+20],[$r1+12],$r4,$r2,$r3
	sqr_add_c2 [$r1+24],[$r1+8],$r4,$r2,$r3
	sqr_add_c2 [$r1+28],[$r1+4],$r4,$r2,$r3
	move.d $r4,[$r0+]
	clear.d $r4

	sqr_add_c2 [$r1+28],[$r1+8],$r2,$r3,$r4
	sqr_add_c2 [$r1+24],[$r1+12],$r2,$r3,$r4
	sqr_add_c2 [$r1+20],[$r1+16],$r2,$r3,$r4
	move.d $r2,[$r0+]
	clear.d $r2

	sqr_add_c [$r1+20],$r3,$r4,$r2
	sqr_add_c2 [$r1+24],[$r1+16],$r3,$r4,$r2
	sqr_add_c2 [$r1+28],[$r1+12],$r3,$r4,$r2
	move.d $r3,[$r0+]
	clear.d $r3

	sqr_add_c2 [$r1+28],[$r1+16],$r4,$r2,$r3
	sqr_add_c2 [$r1+24],[$r1+20],$r4,$r2,$r3
	move.d $r4,[$r0+]
	clear.d $r4

	sqr_add_c [$r1+24],$r2,$r3,$r4
	sqr_add_c2 [$r1+28],[$r1+20],$r2,$r3,$r4
	move.d $r2,[$r0+]
	clear.d $r2

	sqr_add_c2 [$r1+28],[$r1+24],$r3,$r4,$r2
	move.d $r3,[$r0+]
	clear.d $r3

	sqr_add_c [$r1+28],$r4,$r2,$r3
	move.d $r4,[$r0+]
	move.d $r2,[$r0+]
	
	;; end
	movem [$sp+],$r4
	jump [$sp+]

	;; snagged from gcc-cris output
	.align 1
	.globl bn_div_words
 	.type bn_div_words,@function
bn_div_words:
	Push $srp
	subq 24,$sp
	movem $r5,[$sp]
	move.d $r10,$r0
	clear.d $r1
	move.d $r0,$r5
	clear.d $r4
	move.d $r11,$r9
	clear.d $r10
	move.d $r9,$r0
	move.d $r5,$r1
	move.d $r12,$r2
	clear.d $r3
	move.d $r0,$r10
	move.d $r5,$r11
	move.d $r2,$r12
	clear.d $r13
	Jsr __udivdi3
	move.d $r10,$r12
	move.d $r11,$r13
	move.d $r12,$r10
	movem [$sp+],$r5
	jump [$sp+]

